﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace gsmagic {
    static class Bits {
        public static byte[] openFile(string filename) {
            try {
                return System.IO.File.ReadAllBytes(filename);
                //path = filename;
            } catch {
                return null;
            }
        }
        public static void saveFile(string filename, byte[] buffer) {
            System.IO.File.WriteAllBytes(filename, buffer);
            //path = filename;
        }
        static public int getInt16(byte[] buffer, int pos) { //(int addr)
            return buffer[pos++] | (buffer[pos] << 8);
        }
        static public int getInt16(byte[] buffer, uint pos) { //(int addr)
            return buffer[pos++] | (buffer[pos] << 8);
        }
        static public int getInt32(byte[] buffer, int pos) { //(int addr)
            return buffer[pos++] | (buffer[pos++] << 8) | buffer[pos++] << 16 | (buffer[pos] << 24);
        }
        static public void setInt32(byte[] buffer, int pos, int value) { //(int addr)
            buffer[pos++] = (byte)value;
            buffer[pos++] = (byte)(value >> 8);
            buffer[pos++] = (byte)(value >> 16);
            buffer[pos++] = (byte)(value >> 24);
        }
        static public uint getUInt32(byte[] buffer, int pos) { //(int addr)
            return unchecked((uint)(buffer[pos++] | (buffer[pos++] << 8) | buffer[pos++] << 16 | (buffer[pos] << 24)));
        }
        public static string getString(byte[] buffer, int pos, int length) {
            System.Text.StringBuilder strbuild = new System.Text.StringBuilder(16);
            while (length-- > 0) {
                strbuild.Append((char)buffer[pos++]);
            }
            return strbuild.ToString();
        }
    }
}
