﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace gsmagic {
    //static class Comp {
    partial class Form1 { //Partial because I don't want to duplicate "static" across all functions.
        public int decompress(byte[] src, int srcPos, byte[] des, int desPos) {
            int desStart = desPos; //Needed for when Distance is variable bits.
            //byte[] des = new byte[0x10000]; //Largest size ever needed.
        //public byte[] decompress(byte[] src, int srcPos, int desPos) {
        //    byte[] des = new byte[0x10000]; //Largest size ever needed.
            int bits, readcount, i, _byte; //offset;
            uint n; ulong z = 0xFEDCBA9876543210;
            int format = src[srcPos++];
            if (format == 0 || format == 2) {
                bits = 0;
                int bitnum = 0;
                if ((srcPos & 1) == 1) {  bits = src[srcPos++]; bitnum = 8; } //Optional
                bits += ((int)src[srcPos++] << bitnum) + ((int)src[srcPos++] << (8 + bitnum));
                while (true) {
                    readcount = 0;
                    if ((bits & 1) == 1) {
                        bits >>= 1; bitnum -= 1;
                        if (format == 0) { //Format 0: Constant
                            des[desPos++] = (byte)bits; bits >>= 8; bitnum -= 8;
                        } else { //Format 2: Recent Priority
                            if ((bits & 1) == 1) {
                                i = 2; bits >>= 1; bitnum -= 1;
                            } else if ((bits & 2) == 2) {
                                i = 3; bits >>= 2; bitnum -= 2;
                            } else {
                                i = 4; bits >>= 2; bitnum -= 2;
                            }
                            for (int offset = 0; offset < 8; offset += 4) {
                                _byte = (bits & ((1 << i) - 1)); bits >>= i; bitnum -= i; //Read from compressed data.
                                n = (uint)(0xF & (z >> (int)(_byte << 2))); //Get selected value.
                                if (_byte != 0xF) { // Check 0xF because <<0x40 does nothing. (ex: no-op?)
                                    z = (z & (unchecked((ulong)-1) << ((_byte + 1) << 2))) //Keep tail end.
                                        | ((z & ((((ulong)1) << (_byte << 2)) - 1)) << 4) //Close gap.
                                        | n; //Put selected value in front.
                                } else { z = (z << 4) | n; }
                                des[desPos] |= (byte)(n << offset); //Write decompressed 4-bit.
                            }
                            desPos++;
                        }
                        if (bitnum < 0) {
                            bitnum += 16;
                            bits += ((int)src[srcPos++] << bitnum) + ((int)src[srcPos++] << (8 + bitnum));
                        }
                    } else if ((bits & 3) == 0) { //Format 0 & 2: Distance Length: Length
                        readcount = 2; bits >>= 2; bitnum -= 2;
                    } else if ((bits & 7) == 2) {
                        readcount = 3; bits >>= 3; bitnum -= 3;
                    } else if ((bits & 0xF) == 6) {
                        readcount = 4; bits >>= 4; bitnum -= 4;
                    } else if ((bits & 0x1F) == 0xE) {
                        readcount = 5; bits >>= 5; bitnum -= 5;
                    } else if ((bits & 0x7F) == 0x1E) {
                        readcount = 6; bits >>= 7; bitnum -= 7;
                    } else if ((bits & 0x7F) == 0x5E) {
                        readcount = 7; bits >>= 7; bitnum -= 7;
                    } else if ((bits & 0x3F) == 0x3E) {
                        readcount = 7 + ((bits >> 6) & 3); bits >>= 8; bitnum -= 8;
                        if (readcount == 7) {
                            readcount = 10 + (bits & 127); bits >>= 7; bitnum -= 7;
                            if (readcount == 10) { return desPos; } // des; }
                        }
                    }
                    if (bitnum < 0) {
                        bitnum += 16;
                        bits += ((int)src[srcPos++] << bitnum) + ((int)src[srcPos++] << (8 + bitnum));
                    }
                    if (readcount != 0) { //Format 0 & 2: Distance Length: Distance
                        uint offset = 0;
                        if ((bits & 1) == 0) { //Long Distance - 0~12-bit distance
                            bits >>= 1; bitnum -= 1;
                            offset = (uint)desPos - (uint)desStart - 33;
                            _byte = 12;
                            while (offset < (1 << (_byte - 1))) {
                                _byte -= 1;
                            }
                            offset = (uint)(32 + (bits & ((1 << _byte) - 1))); bits >>= _byte; bitnum -= _byte;
                        } else { //Short Distance - 5-bit distance
                            bits >>= 1; bitnum -= 1;
                            offset = (uint)(bits & 31); bits >>= 5; bitnum -= 5;
                        }
                        if (bitnum < 0) {
                            bitnum += 16;
                            bits += ((int)src[srcPos++] << bitnum) + ((int)src[srcPos++] << (8 + bitnum));
                        }
                        //if (desPos < offset) { return null; }
                        while (readcount-- > 0) {
                            des[desPos] = des[desPos - offset - 1]; desPos++;
                        }
                    }
                }
            } else { //Format 1
                while (true) {
                    bits = src[srcPos++];
                    for (int j = 0x80; j > 0; j >>= 1) {
                        if ((bits & j) == 0) {
                            des[desPos++] = src[srcPos++];
                        } else {
                            readcount = src[srcPos++];
                            int offset = src[srcPos++] | ((readcount & 0xF0) << 4);
                            readcount = readcount & 15;
                            if (readcount == 0) {
                                if (offset == 0) { return desPos; } // des; }
                                readcount = src[srcPos++] + 16;
                            }
                            //if (desPos < offset) { return null; }
                            while (readcount-- >= 0) {
                                des[desPos] = des[desPos - offset]; desPos++;
                            }
                        }
                    }
                }
            }
            //return des;
        }

        public byte[] decompress16(byte[] src, int srcPos, int desPos) {
            byte[] des = new byte[0x4000];
            int bits = 0, i = 0, bitnum = 0;
            uint n; ulong z = 0xFEDCBA9876543210;
            bits += ((int)src[srcPos++] << bitnum) + ((int)src[srcPos++] << (8 + bitnum));
            while (true) {
                if ((bits & 0x1) == 0x0) {
                    i = 0; bits >>= 1; bitnum -= 1;
                } else if ((bits & 0x7) == 0x1) {
                    i = 1; bits >>= 3; bitnum -= 3;
                } else if ((bits & 0xF) == 0x5) {
                    i = 2; bits >>= 4; bitnum -= 4;
                } else if ((bits & 0xF) == 0xD) {
                    i = 3; bits >>= 4; bitnum -= 4;
                } else if ((bits & 0xF) == 0x3) {
                    i = 4; bits >>= 4; bitnum -= 4;
                } else if ((bits & 0xF) == 0xB) {
                    i = 5; bits >>= 4; bitnum -= 4;
                } else if ((bits & 0xF) == 0x7) {
                    i = 6; bits >>= 4; bitnum -= 4;
                } else if ((bits & 0x3F) == 0xF) {
                    i = 7; bits >>= 6; bitnum -= 6;
                } else if ((bits & 0x3F) == 0x2F) {
                    i = 8; bits >>= 6; bitnum -= 6;
                } else if ((bits & 0x3F) == 0x1F) {
                    i = 9; bits >>= 6; bitnum -= 6;
                } else if ((bits & 0xFF) == 0x3F) {
                    i = 10; bits >>= 8; bitnum -= 8;
                } else if ((bits & 0xFF) == 0xBF) {
                    i = 11; bits >>= 8; bitnum -= 8;
                } else if ((bits & 0xFF) == 0x7F) {
                    i = 12; bits >>= 8; bitnum -= 8;
                } else if ((bits & 0x3FF) == 0xFF) {
                    i = 13; bits >>= 10; bitnum -= 10;
                } else if ((bits & 0x3FF) == 0x2FF) {
                    i = 14; bits >>= 10; bitnum -= 10;
                } else if ((bits & 0x3FF) == 0x1FF) {
                    i = 15; bits >>= 10; bitnum -= 10;
                } else if ((bits & 0x3FF) == 0x3FF) {
                    return des;
                }
                n = (uint)(0xF & (z >> (int)(i << 2))); //Get selected value.
                if (i != 0xF) { // Check 0xF because <<0x40 does nothing. (ex: no-op?)
                    z = (z & (unchecked((ulong)-1) << ((i + 1) << 2))) //Keep tail end.
                        | ((z & ((((ulong)1) << (i << 2)) - 1)) << 4) //Close gap.
                        | n; //Put selected value in front.
                } else { z = (z << 4) | n; }
                des[desPos++] = (byte)n; //Write decompressed 4-bit.

                if (bitnum < 0) {
                    bitnum += 16;
                    bits += ((int)src[srcPos++] << bitnum) + ((int)src[srcPos++] << (8 + bitnum));
                }
            }
        }
        int[] bitTable = {0x1, 0x0, 0x3, 0x1, 0x4, 0x5, 0x4, 0xD,
                                 0x4, 0x3, 0x4, 0xB, 0x4, 0x7, 0x6, 0xF,
                                 0x6, 0x2F, 0x6, 0x1F, 0x8, 0x3F, 0x8, 0xBF,
                                 0x8, 0x7F, 0xA, 0xFF, 0xA, 0x2FF, 0xA, 0x1FF,
                                 0xA, 0x3FF};
        void compress16(byte[] src, int srcPos, byte[] des, int desPos) { //Not tested.
            int bitnum = 0, bits = 0, i = 0;
            uint n = 0; ulong z = 0xFEDCBA9876543210;
            while (srcPos < src.Length) { //Length may be changed?
                while ((((z >> i) & 0xF) != src[srcPos])) {
                    i += 4;
                }
                bits = bits | (bitTable[(i >> 1) + 1] << bitnum); bitnum += bitTable[i >> 1];
                while (bitnum >= 8) {
                    des[desPos] = (byte)bits; bits >>= 8; bitnum -= 8;
                }

                n = (uint)(0xF & (z >> (int)i)); //Get selected value.
                if (i != 0x3C) { // Check 0xF because <<0x40 does nothing. (ex: no-op?)
                    z = (z & (unchecked((ulong)-1) << (i + 4))) //Keep tail end.
                        | ((z & ((((ulong)1) << i) - 1)) << 4) //Close gap.
                        | n; //Put selected value in front.
                } else { z = (z << 4) | n; }
                srcPos++;
            }
            bits = bits | (bitTable[0x21] << bitnum); bitnum += bitTable[0x20];
            while (bitnum > 0) {
                des[desPos] = (byte)bits; bits >>= 8; bitnum -= 8;
            }
        }
        byte[] decompBtlBG(byte[] src, int srcPos) {
            byte[] des = new byte[0x8000]; int desPos = 0;
            int bits = 0, i = 0x60, bitnum = 0;
            bits += ((int)src[srcPos++] << bitnum) + ((int)src[srcPos++] << (8 + bitnum));
            for (int j = 0; j < 0x7800; j++) {
                switch (bits & 7) {
                    case 0:
                    case 4:
                        bits >>= 2; bitnum -= 2;
                        break;
                    case 1:
                        bits >>= 3; bitnum -= 3;
                        i += 1 + (bits & 1); bits >>= 1; bitnum -= 1;
                        break;
                    case 2:
                        bits >>= 3; bitnum -= 3;
                        if ((bits & 1) == 0) {
                            bits >>= 1; bitnum -= 1;
                            i += 11 + (bits & 0xF); bits >>= 4; bitnum -= 4;
                        } else {
                            bits >>= 1; bitnum -= 1;
                            i -= 11 + (bits & 0xF); bits >>= 4; bitnum -= 4;
                        }
                        break;
                    case 3:
                        bits >>= 3; bitnum -= 3;
                        i += 3 + (bits & 7); bits >>= 3; bitnum -= 3;
                        break;
                    case 5:
                        bits >>= 3; bitnum -= 3;
                        i -= 1 + (bits & 1); bits >>= 1; bitnum -= 1;
                        break;
                    case 6:
                        bits >>= 3; bitnum -= 3;
                        i = 0x60 + (bits & 0x7F); bits >>= 7; bitnum -= 7;
                        break;
                    case 7:
                        bits >>= 3; bitnum -= 3;
                        i -= 3 + (bits & 7); bits >>= 3; bitnum -= 3;
                        break;
                }
                des[desPos++] = (byte)i;
                if (bitnum < 0) {
                    bitnum += 16;
                    bits += ((int)src[srcPos++] << bitnum) + ((int)src[srcPos++] << (8 + bitnum));
                }
            }
            return des;
        }
        byte[] decompText(byte[] src) { //, int srcInd) { // int srcPos) {
            byte[] des = new byte[0x800000]; int desEntry = 0, desPos = 0xC300;
            for (int srcI = 0; srcI < 12461; srcI++) {
                Bits.setInt32(des, desEntry, desPos - 0xC300); desEntry += 4;
                int srcInd = srcI;
                int textTree = Bits.getInt32(src, 0xA9F54 + ((srcInd >> 8) << 3)) - 0x08000000;
                int textLenAddr = Bits.getInt32(src, 0xA9F54 + ((srcInd >> 8) << 3) + 4) - 0x08000000;
                srcInd &= 0xFF;
                while (srcInd-- != 0) {
                    int cLen;
                    do {
                        cLen = src[textLenAddr++];
                        textTree += cLen;
                    } while (cLen == 0xFF);
                }
                int initChar = 0;
                int chardata = Bits.getInt32(src, 0x60C30) - 0x08000000;
                int charpntrs = Bits.getInt32(src, 0x60C34) - 0x08000000;
                textTree <<= 3;
                do {
                    int charTree = (chardata + Bits.getInt16(src, charpntrs + (initChar << 1))) << 3;
                    int charSlot = charTree - 12;
                    while (((src[charTree >> 3] >> (charTree++ & 7)) & 1) == 0) {
                        if (((src[textTree >> 3] >> (textTree++ & 7)) & 1) == 1) {
                            int depth = 0;
                            while (depth >= 0) {
                                while (((src[charTree >> 3] >> (charTree++ & 7)) & 1) == 0) {
                                    depth++;
                                }
                                charSlot -= 12;
                                depth--;
                            }
                        }
                    }
                    initChar = (Bits.getInt16(src, charSlot >> 3) >> (charSlot & 7)) & 0xFFF;
                    des[desPos++] = (byte)initChar;
                    //do {
                    // n=getNextCharacter(argument0)
                    // if n!=0 {
                    //  if (n<32 || n>ord('~')) {
                    //   if argument2
                    //   { str+='['+string(n)+']'; }
                    //   if argument3 && (n==1 || n==3) && (p<17 || p>20) && p!=26 && p!=29
                    //   { n=0 }
                    //  } else { str+=chr(n); }
                    // }
                    // p=n
                    //} until n=0
                } while (initChar != 0);
            }
            return des;
        }
        public void comptext(byte[] src) {
            //Generate char tables!
            //Scan text to generate frequency table.
            short char1 = 0, char2 = 0;
            short[] freq = new short[0x10000]; //We need to know how often each character combination occurs to determine best bit amounts.
            short[] clen = new short[0x100]; //How many chars each char has associated with it.
            short[] clst = new short[0x10000]; //Char list in the order they appear in the text.
            int srcEntry = 0;
            while (Bits.getInt32(src, srcEntry) != 0) { //Set up frequency table and char list (in order displayed in text.)
                int srcPos = 0xC300 + Bits.getInt32(src, srcEntry);
                do {
                    char2 = src[srcPos++];
                    if (freq[char1 * 0x100 + char2]++ == 0) {
                        clst[char1 * 0x100 + clen[char1]++] = char2; //clen[char1]++;// += 1;
                    }
                    //freq[char1 * 0x100 + char2] += 1;
                    char1 = char2;
                } while (char1 != 0); //Change to while < textArray?-- No, go through offset list instead.
                srcEntry += 4;
            }
            //Make list that points from least frequent char to most frequent char.
            int[] cltg = new int[0x10000]; //short[] cltg = new short[0x10000]; //Chars least to greatest - Swap to 0x200(?)(Esp. if contains node info) bytes and use same memory for all chars. (Since don't need them simutaneously.)
            for (int charScan = 0; charScan < 0x100; charScan++) {
                int wgtMin = 1, wgt1 = 0xffff, wgt2 = 0xffff, wfInd = 0;
                for (int j = 0; j < 0x0100; j++) {
                    //Find first lowest...
                    for (int i = 0; i < clen[j]; i++) {
                        int wgt = freq[j * 0x100 + clst[j * 0x100 + i]];
                        if (wgtMin <= wgt) {
                            if (wgt < wgt1) {
                                wgt1 = wgt;
                                wfInd = j * 0x100 + clst[j * 0x100 + i];
                            }
                        }
                    }
                    wgtMin = wgt1;
                    freq[wfInd] = 0; //Temp?
                    //Find second lowest...
                    for (int i = 0; i < clen[j]; i++) {
                        int wgt = freq[j * 0x100 + clst[j * 0x100 + i]];
                        if (wgtMin <= wgt) {
                            if (wgt < wgt2) {
                                wgt2 = wgt;
                                wfInd = j * 0x100 + clst[j * 0x100 + i];
                            }
                        }
                    }
                    wgtMin = wgt2;
                    freq[wfInd] = 0; //Temp?

                    cltg[0] = wgt1;
                    cltg[1] = wgt2;


                }
                //int first = 0, last = 0, prev = 0, next = 0, i = 0;
                //int len = 1;
                //while (i != last) { //Note: When a number points to itself, it is the largest?
                //    int curfreq = freq[charScan * 0x100 + clst[charScan * 0x100 + i]];
                //    if (curfreq < freq[charScan * 0x100 + clst[charScan * 0x100 + prev]]) {

                //    } else if (curfreq < freq[charScan * 0x100 + clst[charScan * 0x100 + next]]) {

                //    }
                //}
            }

            //Node table with weight/freq values and pointer info....

            //Make Char tables to be put in ROM.

            //Compress text.
        }
        //Temp - For testing/ Char-pair analysis.
        public string decompStr(byte[] src, int srcInd, int num) { // int srcPos) {
            //byte[] des = new byte[0xA0000]; int desPos = 0;
            StringBuilder des = new StringBuilder(0x200);
            //short[] info = new short[0x10000];
            //for (int srcInd1 = 0; srcInd1 <= 0x30AC; srcInd1++) {
                //int srcInd = srcInd1;
                int textTree = Bits.getInt32(src, 0xA9F54 + ((srcInd >> 8) << 3)) - 0x08000000;
                int textLenAddr = Bits.getInt32(src, 0xA9F54 + ((srcInd >> 8) << 3) + 4) - 0x08000000;
                srcInd &= 0xFF;
                while (srcInd-- != 0) {
                    int cLen;
                    do {
                        cLen = src[textLenAddr++];
                        textTree += cLen;
                    } while (cLen == 0xFF);
                }
                int initChar = 0;
                int chardata = Bits.getInt32(src, 0x60C30) - 0x08000000;
                int charpntrs = Bits.getInt32(src, 0x60C34) - 0x08000000;
                textTree <<= 3;
                do {
                    int charTree = (chardata + Bits.getInt16(src, charpntrs + (initChar << 1))) << 3;
                    int charSlot = charTree - 12;
                    while (((src[charTree >> 3] >> (charTree++ & 7)) & 1) == 0) {
                        if (((src[textTree >> 3] >> (textTree++ & 7)) & 1) == 1) {
                            int depth = 0;
                            while (depth >= 0) {
                                while (((src[charTree >> 3] >> (charTree++ & 7)) & 1) == 0) {
                                    depth++;
                                }
                                charSlot -= 12;
                                depth--;
                            }
                        }
                    }
                    //int loc = initChar * 0x100;
                    initChar = (Bits.getInt16(src, charSlot >> 3) >> (charSlot & 7)) & 0xFFF;
                    //info[loc + initChar] += 1;
                    //des[desPos++] = (byte)initChar;
                    if ((num == 1) && initChar < 30) {
                        //des.Append("[" + initChar.ToString() + "]");
                    } else {
                        des.Append((char)initChar);
                    }
                } while (initChar != 0);
            //}
            //byte[] result = new byte[info.Length * sizeof(short)];
            //Buffer.BlockCopy(info, 0, result, 0, result.Length);
            return des.ToString();
        }


        //Function for viewing hex-code of chars.
        //void idc(byte[] src) {
        //    int initChar = 0;
        //    int chardata = Bits.getInt32(src, 0x60C30) - 0x08000000;
        //    int charpntrs = Bits.getInt32(src, 0x60C34) - 0x08000000;
        //    //textTree <<= 3;
        //    do {
        //        int charTree = (chardata + Bits.getInt16(src, charpntrs + (initChar << 1))) << 3;
        //        int charSlot = charTree - 12;
        //        int hexCode = 0;
        //        int flip = 1;
        //        while (((src[charTree >> 3] >> (charTree++ & 7)) & 1) == 0) {
        //            flip <<= 1; //hexCode ^= flip;
        //            //if (((src[textTree >> 3] >> (textTree++ & 7)) & 1) == 1) {
        //                int depth = 0;
        //                while (depth >= 0) {
        //                    while (((src[charTree >> 3] >> (charTree++ & 7)) & 1) == 0) {
        //                        depth++;
        //                    }
        //                    charSlot -= 12;
        //                    depth--;
        //                }
        //            //}
        //        }
        //        //Write char's line.
        //        initChar += 1; // (Bits.getInt16(src, charSlot >> 3) >> (charSlot & 7)) & 0xFFF;
        //        //des[desPos++] = (byte)initChar;
        //        //do {
        //        // n=getNextCharacter(argument0)
        //        // if n!=0 {
        //        //  if (n<32 || n>ord('~')) {
        //        //   if argument2
        //        //   { str+='['+string(n)+']'; }
        //        //   if argument3 && (n==1 || n==3) && (p<17 || p>20) && p!=26 && p!=29
        //        //   { n=0 }
        //        //  } else { str+=chr(n); }
        //        // }
        //        // p=n
        //        //} until n=0
        //    } while (initChar < 0x100);
        //}
    }
}
