﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing; //Bitmap /May later need for Rectangle as well.
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

//using System.Drawing; //Bitmap/Rectangle
using System.Drawing.Imaging; //PixelFormat
using System.Runtime.InteropServices; //Marshal

namespace gsmagic {
    public partial class Form1 : Form {
        public Form1() {
            InitializeComponent();
        }
        //Form load > Open/Save ROM
        private void Form1_Load(object sender, EventArgs e) {
            //MessageBox.Show((unchecked((ulong)-1)<<0x40).ToString("X16"));
            
            if (System.IO.File.Exists(Properties.Settings.Default.LastRom)) { OpenROM(Properties.Settings.Default.LastRom); } else { OpenROMdialogue(); }
            //DateTime a = DateTime.Now;//.Ticks;
            //byte[] t = decompress(rom, 0xA8B1B8, 0); //Format 2
            //byte[] t = decompress(rom, 0x888FE4 + 0x80, 0); //Format 2
            //byte[] t = decompress16(rom, 0x4F157, 0); //Format 2
            //byte[] t = decompText(rom, 0x111); // decompBtlBG(rom, 0x7765D8 + 0x100);
            //byte[] t = decompText(rom);
            //DateTime c = DateTime.Now;//.Ticks;
            //Console.WriteLine((c - a).ToString());
            //System.IO.File.WriteAllBytes("C:/Users/Tea/Desktop/gsdtest.dmp", t);
            DateTime a = DateTime.Now;//.Ticks;
            loadEntireMap();
            DateTime c = DateTime.Now;//.Ticks;
            Console.WriteLine((c - a).ToString());
            //System.IO.File.WriteAllBytes("C:/Users/Tea/Desktop/gsdtest2.dmp", decompText(rom));
        }
        private void OpenROMdialogue() {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Title = "Open a GBA/NDS File";
            ofd.Filter = "GBA/NDS/3DS file(*.gba;*.nds;*.3ds)|*.gba;*.nds;*.3ds";
            if (ofd.ShowDialog() == DialogResult.OK) { OpenROM(ofd.FileName); }
        }
        //public static Bits rom = new Bits();
        //public static Bits ram = new Bits();
        //Public OpenFileDialog1 = ""
        public byte[] rom;
        string romfn;
        int version = -1;
        int filetable = -1;
        char language;
        private void OpenROM(string filename) { //TODO: If new filename is error/incompatible, revert to old file.
            //mainMem.setPath(filename)
            //string vstr = ""; //Dim vstr As String = ""
            if (filename.EndsWith(".gba", true, null)) { //Load entire ROM to buffer; GBA ROMs are maxed at 32 MB.
                rom = Bits.openFile(filename);
                if (rom == null) { this.Text = "Error reading ROM file."; return; }
                //rom.seek(0xA0);
                //vstr = Bits.getString(rom, 0xA0, 16);
                //ram.buffer = new byte[0x40000];
                switch (Bits.getString(rom, 0xA0, 15)) {
                    case "Golden_Sun_AAGS":
                    case "OugonTaiyo_AAGS":
                        version = 0; filetable = 0x08320000; break;
                    case "GOLDEN_SUN_BAGF":
                    case "OUGONTAIYO_BAGF":
                        version = 1; filetable = 0x08680000; break;
                    case "MARIOTENNISABTM":
                        version = 11; filetable = 0x08C28000; break;
                    case "MARIOGOLFGBABMG":
                        version = 10; filetable = 0x08800000; break;
                    //default:
                    //    MessageBox.Show("Not a compatible ROM.");
                    //    break;
                }
                language = (char)rom[0xAF];
                if (language == 'E' && version == 1) { //Chinese check
                    if (Bits.getUInt32(rom, 0x08090000 & 0x01FFFFFF) == 0xEA00002E && //unchecked((int)0xEA00002E) && //Make UInt?
                        Bits.getUInt32(rom, 0x08090004 & 0x01FFFFFF) == 0x51AEFF24 &&
                        Bits.getUInt32(rom, 0x08090008 & 0x01FFFFFF) == 0x21A29A69 &&
                        Bits.getUInt32(rom, 0x0809000C & 0x01FFFFFF) == 0x0A82843D) {
                        language = 'C';
                    }
                } else if (version == 0) {
                    switch (language) {
                        case 'E':
                        case 'I': filetable = 0x08320000; break;
                        case 'J': filetable = 0x08317000; break;
                        case 'D': filetable = 0x0831FE00; break;
                        case 'F':
                        case 'S': filetable = 0x08321800; break;
                    }
                }
                //File table verification.
                if (((Bits.getUInt32(rom, filetable & 0x01FFFFFF) >> 24) != 8) ||
                    (Bits.getUInt32(rom, (filetable + 4) & 0x01FFFFFF) != filetable)) {
                    //Incompatible
                }
                //TODO: Reorganize repointed data from Atrius's editor back into where they should belong.
                //Text data, filetable/map code data, Innate psys.
                //count_freespace()
                //init_globals
                //with (obj_MasterEditor) { sel=6*(global.version>=10); event_user(0); }

                //} else if (filename.EndsWith(".nds", true, null)) { //Dark Dawn?
            }
            romfn = filename;
            Properties.Settings.Default.LastRom = filename;
            Properties.Settings.Default.Save();
            loadEntireMap();
        }
        //Toolbar > File menu
        private void openToolStripMenuItem_Click(object sender, EventArgs e) {
            OpenROMdialogue();
        }
        private void saveToolStripMenuItem_Click(object sender, EventArgs e) {
            Bits.saveFile(romfn, rom);
        }
        private void saveAsToolStripMenuItem_Click(object sender, EventArgs e) {
            SaveFileDialog sfd = new SaveFileDialog();
            sfd.Title = "Save ROM File";
            //sfd.Filter = "GBA/NDS/3DS file(*.gba;*.nds;*.3ds)|*.gba;*.nds;*.3ds";
            if (sfd.ShowDialog() == DialogResult.OK) {
                Bits.saveFile(romfn, rom);
                romfn = sfd.FileName;
                Properties.Settings.Default.LastRom = romfn;
                Properties.Settings.Default.Save();
            }
        }
        private void nextMapToolStripMenuItem_Click(object sender, EventArgs e) {
            if (sel == map_num) { return; }
            sel += 1;
            loadEntireMap();
        }

        private void previousMapToolStripMenuItem_Click(object sender, EventArgs e) {
            if (sel == 0) { return; }
            sel -= 1;
            loadEntireMap();
        }
        private void Form1_KeyDown(object sender, KeyEventArgs e) {
            switch (e.KeyCode) {
                case (Keys)0x21:
                    if (sel == map_num) { return; }
                    sel += 1;
                    break;
                case (Keys)0x22:
                    if (sel == 0) { return; }
                    sel -= 1;
                    break;
                //default:
                //    Map.mapNum += 10;
                //    break;
            }
            loadEntireMap();
        }
        int map_num = 0;
        uint sel = 5;
        void loadEntireMap() {
            //init_globals
            filetable &= 0x1FFFFFF;
            uint maps_pos1 = Bits.getUInt32(rom, filetable + 0x18) & 0x1FFFFFF;
            maps_pos1 = Bits.getUInt32(rom, unchecked((int)(maps_pos1 + 0xC))) & 0x1FFFFFF;
            maps_pos1 = Bits.getUInt32(rom, unchecked((int)((maps_pos1 & 0x1FFFFFC) - 4 - 0x3C * ((version == 11) ? 1 : 0)))) & 0x1FFFFFF;

            //ds_map_add(global.data_desc,global.maps_pos1,"Map Data Reference 1")
            uint maps_pos2 = Bits.getUInt32(rom, filetable + 0xC) & 0x1FFFFFF;
            maps_pos2 = Bits.getUInt32(rom, unchecked((int)(maps_pos2 + 0x10C + 0x20 * ((version == 0) ? 1 : 0)))) & 0x1FFFFFF;
            uint maps_off = Bits.getUInt32(rom, unchecked((int)((maps_pos2 & 0x1FFFFFC) - 4 - 0x160 * ((version == 0) ? 1 : 0)))) & 0x1FFFFFF;
            maps_pos2 = Bits.getUInt32(rom, unchecked((int)((maps_pos2 & 0x1FFFFFC) - 8 - 0x164 * ((version == 0) ? 1 : 0)))) & 0x1FFFFFF;

            //ds_map_add(global.data_desc,global.maps_pos2,"Map Data Reference 2")
            int mapid_str = 0;

            if (version == 0) {
                switch (language) {
                    case 'J': mapid_str = 2624; break;
                    case 'E': mapid_str = 2567; break;
                    default: mapid_str = -1; break;
                }
                map_num = 201;
            } else if (version == 1) {
                switch (language) {
                    case 'J': mapid_str = 3772; break;
                    case 'D':
                    case 'S':
                    case 'F':
                    case 'I': mapid_str = 4231; break;
                    case 'E':
                    case 'C': mapid_str = 3770; break;
                    default: mapid_str = -1; break;
                }
                map_num = 325;
            } else if (version == 10) {
                mapid_str = 0;
                map_num = 55;
            } else if (version == 11) {
                mapid_str = 882;
                map_num = 69;
            }
            //obj_eMaps > User Defined 1 //Swap all to Unsigned?
            //uint sel = 16;
            uint loc = (maps_pos1 + 8 * sel) & 0x1FFFFFF; //file_bin_seek(global.file,(global.maps_pos1+8*sel)&$1FFFFFF)
            int code = Bits.getInt16(rom, loc); //show_message(string_hex(READU8(global.file,READU32(global.file,(global.filetable+(code<<2)))),2)+', '+string_hex(dataresource_size(code),8))
            //rom(loc + 2) //Music/Name?
            //rom(loc + 3) //???
            int map = Bits.getInt16(rom, loc + 4);
            loc = unchecked((uint)((maps_pos2 + 12 * map) & 0x1FFFFFF)); //file_bin_seek(global.file,(global.maps_pos2+12*map)&$1FFFFFF)
            int[] pos = new int[6];
            pos[0] = Bits.getInt16(rom, loc);
            pos[1] = Bits.getInt16(rom, loc + 2);
            pos[2] = Bits.getInt16(rom, loc + 4);
            pos[3] = Bits.getInt16(rom, loc + 6);
            pos[4] = Bits.getInt16(rom, loc + 8);
            pos[5] = Bits.getInt16(rom, loc + 10);

            for (int a = 0; a < 6; a++) {
                pos[a] = Bits.getInt32(rom, unchecked((int)(filetable + ((pos[a] + maps_off) << 2)) & 0x1FFFFFF)) & 0x1FFFFFF;
            }
            int world_map = (map == 1) ? 1 : 0;
            /* Skip for now.
 file_bin_seek(global.file,(global.filetable+(code<<2))&$1FFFFFF)
 code=READ_UINT(global.file)
 code_f=decompressMapCode(global.file,code,temp_directory+'\code.bin')
 code=file_bin_open(code_f,2)
             */
            //byte[] t = decompress(rom, 0xA8B1B8, 0); //Format 2
            //byte[] t = decompress(rom, 0x888FE4 + 0x80, 0); //Format 2
            //byte[] t = decompress16(rom, 0x4F157, 0); //Format 2
            //byte[] t = decompText(rom, 0x111); // decompBtlBG(rom, 0x7765D8 + 0x100);
            byte[] paldat = new byte[0x1C0]; //0x200];
            decompress(rom, pos[1], paldat, 0); initPal(paldat, 0, 0xE0); //pictureBox1.Image = PixelsToImage(pal, 16, 14, 16);
            byte[] tsetdat = new byte[0x10000];
            decompress(rom, pos[2], tsetdat, 0x0000);
            decompress(rom, pos[3], tsetdat, 0x4000);
            decompress(rom, pos[4], tsetdat, 0x8000);
            decompress(rom, pos[5], tsetdat, 0xC000);

            int scnw = rom[pos[0] + 0x2] * 8;
            int scnh = rom[pos[0] + 0x3] * 8;

            byte[] stiles = new byte[0x10000]; byte[] tmap = new byte[0x10000];
            //int length =
            decompTileData(rom, pos[0] + (Bits.getInt32(rom, pos[0] + 0x24)), stiles, 0); //8x8 tile table - Decompress & Deobfuscate.
            //Height Tile Data - Skip for now.
            decompMap2(rom, pos[0] + (Bits.getInt32(rom, pos[0] + 0x2C)), tmap, 0); //16x16 tilemap - Decompress & Deobfuscate.
            //Height Tilemap - Skip for now.
            //Animation
            //Visual Effects
            //Coord data

            //shift[0]=READ_UBYTE(global.file)+(READ_UBYTE(global.file)<<7)
            this.Text = sel.ToString();
            //Temporary error avoidance:
            if (scnw == 0) { this.Text += (" (Error - Width was 0)").ToString(); scnw = 16; } //Anti-error for... was it sel 102(?)
            if (scnh == 0) { this.Text += (" (Error - Height was 0)").ToString(); scnh = 16; }
            if ((sel == 175) || (sel == 176) || (sel == 202) || (sel == 229)) { this.Text += (" (Error for 175, 176, 202, and 229)").ToString(); return; }
            int[] bmpdata = new int[scnw * scnh];
            //for (int l = 0; l < 3; l += 1) {
            //    int shift = rom[pos[0] + 0xC + (l * 8)] + (rom[pos[0] + 0xD + (l * 8)] << 7);
            //    for (int dy = 0; dy < rom[pos[0] + 0x3]; dy += 2) {
            //        for (int dx = 0; dx < rom[pos[0] + 0x2]; dx += 2) {
            //            int t = Bits.getInt16(tmap, 0x8000 + dx + shift + (dy << 7)) & 0xFFF;
            //            for (int t8 = 0; t8 < 8; t8 += 2) {
            //                int tile = Bits.getInt16(stiles, t * 8);
            //                int t2 = ((tile & 0x3FF) + ((rom[pos[0] + 7 + l] - 1) * 0x200)) << 5; //+ tset
            //                int tilePal = (tile >> 8) & 0xF0;
            //                for (int n = 0; n < 0x40; n += 2) {
            //                    int ry = y; if ((tile & 0x800) != 0) { ry = r + ((7 - y) & 7); } //Vert. flip
            //                    int rx = x; if ((tile & 0x400) != 0) { rx = c + ((7 - x) & 7); } //Horr. flip
            //                    int pix = tsetdat[t2++];
            //                    int pix2 = pix & 0xF;
            //                    if (pix2 != 0) {
            //                        bmpdata[((dy*8 + (t8&4)*2 + (n>>3)) * width) + rx] = pal[tilePal | (pix2)];
            //                    }
            //                    int rx = x + 1; if ((tile & 0x400) != 0) { rx = c + ((7 - x) & 7); } //Horr. flip
            //                    pix2 = pix >> 4;
            //                    if (pix2 != 0) {
            //                        bmpdata[(ry * width) + rx] = pal[tilePal | (pix2)];
            //                    }
            //                }
            //            }
            //        }
            //    }
            //}
            for (int l = 0; l < 3; l += 1) {
                int shift = rom[pos[0] + 0xC + (l * 8)] + (rom[pos[0] + 0xD + (l * 8)] << 7);
                for (int row = 0; row < (scnh); row += 16) {
                    for (int col = 0; col < (scnw); col += 16) {
                        //int t = Bits.getInt16(tmap, 0x8000 + dx + shift + (dy << 7)) & 0xFFF;
                        int t = (Bits.getInt16(tmap, 0x8000 + (col >> 3) + shift + (row << 4)) & 0xFFF) * 8;
                        for (int r = row; r < row + 16; r += 8) {
                            for (int c = col; c < col + 16; c += 8) {
                                int tile = Bits.getInt16(stiles, t); t += 2;
                                //int t2 = ((tile & 0x3FF) + ((rom[pos[0] + 7 + l] - 1) * 0x200)) << 5; //+ tset
                                int t2 = ((tile & 0x3FF) << 5) + ((rom[pos[0] + 7 + l] - 1) * 0x4000); //+ tset
                                if (t2 >= 0) {
                                    int tilePal = (tile >> 8) & 0xF0;
                                    for (int y = r; y <= r + 7; y++) {
                                        int ry = y; if ((tile & 0x800) != 0) { ry = r + ((7 - y) & 7); } //Vert. flip
                                        //int pix = ram.getInt32(pos); pos += 4;
                                        for (int x = c; x <= c + 7; x += 2) {
                                            int rx = x; if ((tile & 0x400) != 0) { rx = c + ((7 - x) & 7); } //Horr. flip
                                            int pix = tsetdat[t2++];
                                            int pix2 = pix & 0xF;
                                            if (pix2 != 0) {
                                                bmpdata[(ry * scnw) + rx] = pal[tilePal | (pix2)];
                                                //priomap[(ry * bitmapWidth) + rx] = priority;
                                            }
                                            //pix >>= 4;
                                            rx = x + 1; if ((tile & 0x400) != 0) { rx = c + ((7 - (x + 1)) & 7); } //Horr. flip
                                            pix2 = pix >> 4;
                                            if (pix2 != 0) {
                                                bmpdata[(ry * scnw) + rx] = pal[tilePal | (pix2)];
                                                //priomap[(ry * bitmapWidth) + rx] = priority;
                                            }
                                            //pix >>= 4;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }

            }
            pictureBox1.Width = scnw; pictureBox1.Height = scnh;
            pictureBox1.Image = PixelsToImage(bmpdata, scnw, scnh);
           //System.IO.File.WriteAllBytes("C:/Users/Tea/Desktop/gsdtest.dmp", tsetdat); //stiles);
        }
        //void tile_add(int[] mapBmp, int mapPos, byte[] tsetBmp, int tsetPos, int[] pal, int tileInfo) {

        //}
        public int[] pal = new int[0x100];
        public void initPal(byte[] src, int srcPos, int num) { // int[] des, int desPos, int num) { //Loads palette data into 32-bit array with reversed format.
            //rom.seek(0x8C88C8);
            for (int i = 0; i < num; i++) {
                int palt = Bits.getInt16(src, srcPos + (i * 2));
                //pal[i] = (short)(((palt & 0x1F) << 10) | (palt & 0x3E0) | (palt >> 10));
                pal[i] = ((palt & 0x1F) << 0x13) | ((palt & 0x3E0) << 6) | ((palt >> 7) & 0xF8);
            }
        }
        //Only needed to display zoomed in Palette bitmap,
        public static Bitmap PixelsToImage(int[] array, int width, int height, int zoom) {
            if (zoom <= 0) { return new Bitmap(1, 1); }
            int[] array2 = new int[width * height * zoom * zoom];
            //for (int i = 0; i < (width * height); i++) {
            int i = 0;
            for (int yt = 0; yt < (height * zoom) * (width * zoom); yt += (width * zoom) * zoom) {
                for (int xt = yt; xt < yt + (width * zoom); xt += zoom) {
                    int palt = array[i++];
                    for (int y = xt; y < xt + (width * zoom) * zoom; y += (width * zoom)) {
                        for (int x = y; x < y + zoom; x++) {
                            array2[x] = palt;
                        }
                    }
                }
            }
            return PixelsToImage(array2, width * zoom, height * zoom);
        }
        public static Bitmap PixelsToImage(int[] array, int width, int height) {
            Bitmap bitmap = new Bitmap(width, height, PixelFormat.Format32bppRgb);
            Rectangle rect = new Rectangle(0, 0, bitmap.Width, bitmap.Height);
            BitmapData bitmapData = bitmap.LockBits(rect, ImageLockMode.ReadWrite, bitmap.PixelFormat);
            IntPtr pNative = bitmapData.Scan0;
            Marshal.Copy(array, 0, pNative, width * height);
            bitmap.UnlockBits(bitmapData);
            return bitmap;
        }

        void decompTileData(byte[] src, int srcPos, byte[] des, int desPos) {
            byte[] t = new byte[0x10000];
            int length = decompress(src, srcPos, t, desPos);
            //byte[] stiles = new byte[0x8000];
            int i = 0, pos1, pos2, n = 0;
            switch (t[0]) {
                case 1:
                    pos2 = (length >> 1) + 1;
                    for (pos1 = 1; pos1 < (length >> 1); i += 2) {
                        n ^= ((t[pos1++] << 8) | (t[pos2++]));
                        des[i] = (byte)n; des[i + 1] = (byte)(n >> 8);
                    }
                    break;
                case 2:
                    for (i = 1; i < (length - 1); i += 2) {
                        n ^= t[i] | (t[i + 1] << 8);
                        des[i - 1] = (byte)n; des[i] = (byte)(n >> 8);
                    }
                    break;
                default: //case 0:
                    for (i = 0; i < length; i++) {
                        des[i] = t[i + 1];
                    }
                    break;
            }
            length--;
        }
        void decompMap2(byte[] src, int srcPos, byte[] des, int desPos) {
            decompress(src, srcPos, des, desPos);
            uint b = 0xFFFFF001, pos1, num;
            for (pos1 = 0x8000; pos1 < 0x10000; pos1 += 2) {
                num = (uint)(des[pos1] | (des[pos1 + 1] << 8));
                if ((num << 20) == 0xFFF00000) {
                    num += b;
                    if (b != 0) { b++; }
                }
                des[pos1] = (byte)num; des[pos1 + 1] = (byte)(num >> 8);
            }
        }

        private void editorsToolStripMenuItem_Click(object sender, EventArgs e) {
            Editors eds = new Editors();
            eds.test = this;
            eds.Show();
        }
    }
}